<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>GitHub, GitLab</title>

    <meta name="description" content="ESTP 2023 course, day 2: GitHub and GitLab">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_4.3.1.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Nunito">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Assistant">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-markdown data-state="blue_overlay 9 yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background-video="./files/Team - 70345.mp4" data-background-video-loop data-background-video-muted="true">
<!-- https://pixabay.com/videos/team-office-work-success-70345/ -->
<textarea data-template>

# GitHub, GitLab

<br>
<br>

<a href="mailto:o.mussmann@esciencecenter.nl">Ole Mussmann</a> | <a href="https://www.esciencecenter.nl/">eScience Center</a> | <img style="height: 2.5vw; padding: 0 .5vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/eu_logo.png"><img style="height: 2vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/logo_icon.jpg">

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/checklist-2589418_1920.jpg">
<textarea data-template>

## Table of Contents

- [SSH](#/ssh)
- [GitHub](#/github)
- [GitLab](#/gitlab)
- [Git{Hub,Lab} in Action](#/action)
  - [Set Up](#/set_up)
  - [Issues, Milestones, Boards](#/issues)
  - [Branches, Tags](#/branches)
  - [Forking, {Pull,Merge} Requests](#/requests)
  - [Automation](#/automation)
- [Summary](#/summary)
- [Links](#/links)
- [💻 Exercise](#/exercise)

</textarea>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" id="ssh">
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

# SSH
## Secure SHell protocol


</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->

## In a Nutshell

_Encrypted communication via unsecured networks_

- Asymmetric encryption
  - Public and private keys
- Client-server architecture
- "Passwordless" authentication
  - Private keys can be encrypted
  - Enables service automation

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg">
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## Public key encryption

![Public key encryption](./files/Public_key_encryption.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## Files

<pre data-id="code-animation"><code data-trim data-line-numbers="1">
    ~$ ls .ssh
    authorized_keys
    config
    key1
    key1.pub
    key2
    key2.pub
    known_hosts
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## Files

- Public keys from other machines

<pre data-id="code-animation"><code data-trim data-line-numbers="2">
    ~$ ls .ssh
    authorized_keys
    config
    key1
    key1.pub
    key2
    key2.pub
    known_hosts
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## Files

- Public keys from other machines
- Config file

<pre data-id="code-animation"><code data-trim data-line-numbers="3">
    ~$ ls .ssh
    authorized_keys
    config
    key1
    key1.pub
    key2
    key2.pub
    known_hosts
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## Files

- Public keys from other machines
- Config file
- Public-private key-pairs

<pre data-id="code-animation"><code data-trim data-line-numbers="4-7">
    ~$ ls .ssh
    authorized_keys
    config
    key1
    key1.pub
    key2
    key2.pub
    known_hosts
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## Files

- Public keys from other machines
- Config file
- Public-private key-pairs
- Known hosts
  - Connect without confirmation

<pre data-id="code-animation"><code data-trim data-line-numbers="8">
    ~$ ls .ssh
    authorized_keys
    config
    key1
    key1.pub
    key2
    key2.pub
    known_hosts
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg">
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## SSH Config

<pre><code class="bash">Host gitlab.com
  User git
  IdentitiesOnly yes
  PreferredAuthentications publickey
  IdentityFile /home/ole/.ssh/gitlab

Host my_server
  Port 23
  User me
  Hostname my_server.com
  IdentitiesOnly yes
  PreferredAuthentications publickey
  IdentityFile /home/ole/.ssh/my_server.key
</code></pre>

<pre class="fragment"><code class="bash">~$ ssh -i /home/ole/.ssh/my_server.key -p 23 me@my_server.com
# asking for key passphrase, if applicable
me@my_server:~$ _
</code></pre>

<pre class="fragment"><code class="bash">~$ ssh my_server  # using the config stanza
# asking for key passphrase, if applicable
me@my_server:~$ _
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## SSH key generation

<pre data-id="code-animation"><code data-trim data-line-numbers="1,2">
~$ ssh-keygen \
   -f ~/.ssh/filename  # optional filename
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## SSH key generation

<pre data-id="code-animation"><code data-trim data-line-numbers="2">
~$ ssh-keygen \
   -t ed25519 \        # elliptic curve algorithm
   -f ~/.ssh/filename  # optional filename
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## SSH key generation

<pre data-id="code-animation"><code data-trim data-line-numbers="3">
~$ ssh-keygen \
   -t ed25519 \        # elliptic curve algorithm
   -a 100 \            # encryption rounds (against brute-forcing)
   -f ~/.ssh/filename  # optional filename
</code></pre>

Notes: -a 100 only if you use a passphrase


</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg" data-auto-animate>
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## SSH key generation

<pre data-id="code-animation"><code data-trim data-line-numbers="1-4">
~$ ssh-keygen \
   -t ed25519 \        # elliptic curve algorithm
   -a 100 \            # encryption rounds (against brute-forcing)
   -f ~/.ssh/filename  # optional filename
</code></pre>

<pre><code data-trim>
    ~$ ssh-keygen -t ed25519 -a 100 -f ~/.ssh/filename
    Generating public/private ed25519 key pair.
    Enter passphrase (empty for no passphrase):
    Enter same passphrase again: 
    # listing some key stats
    The key's randomart image is:
    +--[ED25519 256]--+
    |            o.  *|
    |             + +.|
    |          . X B .|
    |         o O @  .|
    |        S * = + .|
    |         ..= o ..|
    |         o=*.E . |
    |        .o=o*.oo |
    |         .=*.o+.=|
    +----[SHA256]-----+
    ~$ _
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/padlock-428549_1280.jpg">
<!-- https://pixabay.com/photos/padlock-locked-secured-lock-428549/ -->
<textarea data-template>

## A fresh SSH key for every service?

<div style="width: 49%; float: left;">
  <h3>One key ...</h3>
  <ul>
    <li>A key is your identity</li>
    <li>You should only need one identity</li>
    <li>A public key is not sensitive</li>
    <li><b>Must</b> be encrypted!</li>
  </ul>
</div>
<div class="fragment" style="width: 49%; float: left;">
  <h3>... or many?</h3>
  <ul>
    <li>Protected in case of breach</li>
    <li>You might need unencrypted keys for automation</li>
    <li>Re-using passwords <b>for this scenario</b> is kind of OK</li>
  </ul>
</div>

<ul class="fragment" style="margin: 1em;">
  <li>I have one key per service</li>
  <li>Passwords are stored in my OS keyring</li>
  <li>... and in my password manager!</li>
</ul>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/github-6615451_1920.png" id="github">
<!-- https://pixabay.com/illustrations/github-software-logo-communication-6615451/ -->
<textarea data-template>

# GitHub
https://github.com

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/github-6615451_1920.png">
<!-- https://pixabay.com/illustrations/github-software-logo-communication-6615451/ -->
<textarea data-template>

## Add SSH keys

- User menu
- Settings
- SSH and GPG keys
- New SSH key
- Give it a **recognizable title**
- Paste your **public** key
- Test it from a terminal

<pre data-id="code-animation"><code data-trim class="bash" data-trim data-line-numbers="1,4|1,2,4|1-4">
~$: ssh \             # ssh command
    -i .ssh/github \  # your identity file
    -T \              # disable (forbidden) terminal access
    git@github.com    # username: git, hostname: github.com
</code></pre>

<pre class="fragment" data-id="code-animation"><code data-trim class="md">
~$: ssh -i .ssh/github -T git@github.com
Hi OleMussmann! You've successfully authenticated, but GitHub does not
provide shell access.
</code></pre>


</textarea>
</section>
</section>

<section>
<section data-markdown data-state="yellow_flag logo black_overlay" data-background="./files/press-kit-icon.svg" data-background-size="contain" id="gitlab">
<!-- https://about.gitlab.com/images/press/press-kit-icon.svg -->
<textarea data-template>

# GitLab
## (Same but different)
https://gitlab.com


</textarea>
</section>

<section data-markdown data-state="yellow_flag logo black_overlay" data-background="./files/press-kit-icon.svg" data-background-size="contain">
<!-- https://about.gitlab.com/images/press/press-kit-icon.svg -->
<textarea data-template>

## Add SSH keys

- User menu
- Preferences
- SSH keys
- Paste your **public** key
- Give it a **recognizable title**
- (Optional) give it an expiration date
- Test it from a terminal

<pre data-id="code-animation"><code data-trim class="bash" data-trim data-line-numbers="1-4">
~$: ssh \             # ssh command
    -i .ssh/gitlab \  # your identity file
    -T \              # disable (forbidden) terminal access
    git@gitlab.com    # username: git, hostname: gitlab.com
</code></pre>

<pre class="fragment" data-id="code-animation"><code data-trim class="md">
~$: ssh -i .ssh/gitlab -T gitlab.com
Welcome to GitLab, @OleMussmann!
</code></pre>


</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/teamwork-3213924_1920.jpg" id="action">
<!-- https://pixabay.com/photos/teamwork-cooperation-brainstorming-3213924/ -->
<textarea data-template>

# Git{Hub,Lab} in Action

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/teamwork-3213924_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/teamwork-cooperation-brainstorming-3213924/ -->

## Manage software projects

- Keep track of bugs, features
  - Plan future development
- Organize branches, tags
- Collaborate with external parties
- Set up a CI/CD pipeline

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/stormtrooper-1343772_1920.jpg" id="set_up">
<!-- https://pixabay.com/photos/stormtrooper-star-wars-lego-storm-1343772/ -->
<textarea data-template>

# Set Up

#### Work on an EXISTING PROJECT
<pre style=""><code data-trim class="bash">
# Create a repository online, and optionally create files
git clone GIT@GITLAB.COM:YOU/PROJECT.GIT  # Use your repo URL here
cd PROJECT
git switch -c main  # Create branch "main" and switch to it
# Do things
git commit -m "did things"
git push -u origin main  # Create branch "main" on the remote repo
</code></pre>

#### ... or push a LOCAL PROJECT
<pre><code data-trim class="bash">
# Create an _EMPTY_ repository online
mkdir PROJECT; cd PROJECT
git init --initial-branch=main  # Create a new repo with trunk "main"
git remote add origin GIT@GITLAB.COM:YOU/PROJECT.GIT  # Use own repo URL
git add .  # Add all local files to the INDEX a.k.a. STAGING AREA
git commit -m "Initial commit"  # Commit added files to the LOCAL REPO
git push -u origin main  # Create branch "main" on the remote repo
</code></pre>
Replace CAPITAL words

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/stormtrooper-1343772_1920.jpg">
<!-- https://pixabay.com/photos/stormtrooper-star-wars-lego-storm-1343772/ -->
<textarea data-template>

# Which protocol?

SSH: [git@gitlab.com:you/project.git](git@gitlab.com:you/project.git)

HTTPS: https://gitlab.com/you/project.git

- You can connect to Git{Hub,Lab} via SSH or HTTPS
  - HTTPS authenticates via access tokens
  - SSH authenticates via ssh key
- HTTPS is fine if you want to just pull code, but ...
  - you need to create access tokens for pushing
  - you need to enter credentials for every push,
    - unless you store it in your OS keyring, which Jupyter can't
- SSH lets you push code passwordless

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="yellow_flag icon purple_overlay" data-background="./files/stone-4811848_1920.jpg" id="issues">
<!-- https://pixabay.com/photos/stone-signpost-old-moss-4811848/ -->
<textarea data-template>

# Issues, Milestones & Boards

</textarea>
</section>

<section data-markdown data-state="yellow_flag icon purple_overlay" data-background="./files/stone-4811848_1920.jpg">
<!-- https://pixabay.com/photos/stone-signpost-old-moss-4811848/ -->
<textarea data-template>

## Issues

#### Describe Bugs or Feature Requests

- Title & description (markdown)
- Assignees
- Custom labels
  - Bug, documentation, good first issue, duplicate, etc.
- Milestones

Notes:
https://github.com/OleMussmann/bad_poem/

Look for someone to fix my poem

Maybe the course participants can help?

Assign: self<br>
Label: good first issue

</textarea>
</section>

<section data-markdown data-state="yellow_flag icon purple_overlay" data-background="./files/stone-4811848_1920.jpg">
<!-- https://pixabay.com/photos/stone-signpost-old-moss-4811848/ -->
<textarea data-template>

## Milestones

#### Collection of Issues & {Merge,Pull} Requests

- Title & description (markdown)
- Due dates

Notes:
Have a great poem by tomorrow<br>
Date: tomorrow<br>

Tie issue to milestone

</textarea>
</section>

<section data-markdown data-state="yellow_flag icon purple_overlay" data-background="./files/stone-4811848_1920.jpg">
<!-- https://pixabay.com/photos/stone-signpost-old-moss-4811848/ -->
<textarea data-template>

## {Boards,Projects}

#### Kanban for Issues

- Drag issues into the right columns
- Automate labels

Notes:
Poem development

Template: Basic kanban

Tie issue to Project

</textarea>
</section>
</section>

<section data-markdown data-state="standard" data-background="./files/trees-3822149_1920.jpg" id="branches">
<!-- https://pixabay.com/photos/trees-wilderness-nature-woods-3822149/ -->
<textarea data-template>

# Branches, Tags
## Just like git

See menu on the top-left

</textarea>
</section>

<section>
<section data-markdown data-state="yellow_flag icon black_overlay" data-background="./files/organization-2478211_1920.jpg" id="requests">
<!-- https://pixabay.com/photos/organization-organization-chart-2478211/ -->
<textarea data-template>

# Forking & {Pull,Merge} Requests
## Collaborate!

</textarea>
</section>

<section data-markdown data-state="yellow_flag icon black_overlay" data-background="./files/organization-2478211_1920.jpg">
<!-- https://pixabay.com/photos/organization-organization-chart-2478211/ -->
<textarea data-template>

## Workflow

- Fork a repository
  - "Copy" it to your own namespace
- Create changes
  - Use branches, tags, issues to your heart's content
- When finished, create a Pull Request (GitHub) or Merge Request (GitLab)
  - Start this process from your own account
- The request can be reviewed and accepted or denied
- An accepted request can be merged to the original repo

Notes:
If you used a different branch, select it in the {}Request menu

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag purple_overlay" data-background="./files/bakery-3457262_1920.jpg" id="automation">
<!-- https://pixabay.com/photos/bakery-rolls-assembly-line-3457262/ -->
<textarea data-template>

# Automation
## Let the Robot Overlords Take Over

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag purple_overlay" data-background="./files/bakery-3457262_1920.jpg">
<!-- https://pixabay.com/photos/bakery-rolls-assembly-line-3457262/ -->
<textarea data-template>

## GitHub Actions /
## GitLab CI/CD<sup>[1]</sup>
#### Do something on {GitHub,GitLab}

- Compile packages
- Run automated tests
- Package code into \*.deb, \*.exe, etc.
- Publish a website on {GitHub,GitLab} Pages
- ...

<footer>[1] Continuous Integration / Continuous Deployment</footer>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag purple_overlay" data-background="./files/bakery-3457262_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/bakery-rolls-assembly-line-3457262/ -->

## Web Hooks
#### Interact with the World

Use REST APIs to
- Publish an external website
- Update an external issue tracker
- Send a Slack notifications on build failures
- Build a Docker container and publish it on <a href="https://hub.docker.com">hub.docker.com</a>
- ...

</textarea>
</section>
</section>

<section data-state="standard 4" data-background="./files/note-pad-1215425_1920.jpg" id="summary">
<!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->

<div style="transform: rotate(-5deg); width: 70%; float: left; margin-left: 4vw;">
  <h2 style="padding: 0; margin: 0;">Summary</h2>
  <ul style="padding-top: 0; margin-top: 0;">
    <li>Git{Hub,Lab} add collaboration to git</li>
    <li>They have an ever-changing, but comparable feature set</li>
    <ul>
      <li>With paid plans for extended features</li>
    </ul>
    <li>They help organizing</li>
    <ul>
      <li>Issues, Milestones, Branches and Tags</li>
      <li>Forking and {Pull,Merge} Requests</li>
      <li>Automation</li>
    </ul>
  </ul>
</div>

</section>
<section data-markdown data-state="logo yellow_flag black_overlay" data-background="./files/earth-3537401_1920.jpg" id="links">
<!-- https://pixabay.com/illustrations/earth-network-blockchain-globe-3537401/ -->
<textarea data-template>

# Resources

- https://github.com
- https://gitlab.com
- https://githubtraining.github.io/training-manual/#/01_getting_ready_for_class
- https://docs.gitlab.com/ee/tutorials/
- Search Engine Optimization (SEO)
  - On Google https://itnext.io/seo-for-open-source-projects-1a6b17ffeb8b
  - On Github https://www.developermarkepear.com/blog/github-search-engine-optimization 

</textarea>
</section>

<section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" id="exercise">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

# Exercise

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Contribute to a project

<div style="font-size: xx-large;">

Help me fix my poem: [github.com/OleMussmann/bad_poem](https://github.com/OleMussmann/bad_poem)

1. Issues  
    - Create an issue, write down poem ideas here  

2. Forking  
   - Fork my repository to your namespace   
   - Fix my poem in the web interface, commit directly to "main"

3. Pull Request   
   - Create a Pull Request from _your_ repository
   - Explain in the message what you did and why it contributes to my project

</div>

</textarea>
</section>
</section>
      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/escience.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
